#!/bin/sh --
eval '(exit $?0)' && eval 'exec perl -w -x -S $0 ${1+"$@"}' && eval 'exec perl 
if 0; # the 1st 4 lines make compatible with kernel/perl/bash/ash/sh/csh
#!perl -w

#
# ar4.pl
# by pts@fazekas.hu at Tue Feb  5 11:06:07 CET 2002
#
# Find and copy the 14 base fonts from the Acrobat Reader 4 distribution --
# and print some info about how to use these fonts with Ghostscript.
#
die "Usage: $0 [Acrobat-Reader-4-dir] dest-dir\n" if @ARGV!=1 and @ARGV!=2;
my($DST,$SRC)=reverse @ARGV;
die "$0: please rm $DST/Fontmap 1st (with care!)\n" if -f"$DST/Fontmap" and not -l"$DST/Fontmap";
unless (defined $SRC) {
  for (split/:/,$ENV{PATH}) {if(-x"$_/acroread"){$SRC="$_/acroread";last}}
  die "$0: Acrobat Reader not found on \$PATH.\n" if! defined $SRC;
  $SRC=readlink $SRC if -l $SRC; # Imp: recursive resolve symlinks in dirs...
  print STDERR "acroread is $SRC\n";
  $SRC=~s@/[^/]+\Z(?!\n)@/..@;
}
my $SR2;
for ($SRC,"$SRC/Font","$SRC/Resource/Font") {
  if (-f"$_/AdobeSerifMM.MMM") {$SR2=$_;last}
}
die "$0: Acrobat Reader fonts not found in $SRC\n" unless defined $SR2;
print STDERR "Acrobat Reader fonts are in $SR2\n";

my %H=qw{
  /Helvetica 			Arial
  /Helvetica-Oblique 		Arial-Italic
  /Helvetica-Bold 		Arial-Bold
  /Helvetica-BoldOblique	Arial-BoldItalic
  /Times-Roman	 		TimesNewRoman
  /Times-Italic			TimesNewRoman-Italic
  /Times-Bold			TimesNewRoman-Bold
  /Times-BoldItalic		TimesNewRoman-BoldItalic
  /Courier			Courier
  /Courier-Oblique		Courier-Oblique
  /Courier-Bold			Courier-Bold
  /Courier-BoldOblique		Courier-BoldOblique
  /Symbol			Symbol
  /ZapfDingbats			ZapfDingbats
};

mkdir "$DST", 0755; # no error checking.
print STDERR "creating $DST/Fontmap\n";
die unless unlink "$DST/Fontmap"; # dangerous?? race condition.
die unless symlink "AR4-Fontmap", "$DST/Fontmap";
print STDERR "creating $DST/AR4-Fontmap\n";
die "$0: $DST/AR4-Fontmap: $!\n" unless open F, "> $DST/AR4-Fontmap";
print F "% AR4-Fontmap for Ghostscript
% Generated by $0 at ", scalar localtime, ". Do not edit!\n";
while (my($K,$V)=each%H) {
  print F "$K (AR4-$V.pfa);\n";
}
print F "% end of AR4-Fontmap\n";
close F;

while (my($K,$V)=each%H) {
  # print STDERR "cp -f '$SR2/$V' '$DST/AR4-$V.pfa';\n";
  print STDERR "copying $DST/AR4-$V.pfa\n";
  die "$0: $SR2/$V: $!\n" unless open F, "< $SR2/$V";
  die unless open G, "> $DST/AR4-$V.pfa";
  print G $_ while sysread F, $_, 4096;
  close G; close F;
}
print STDERR "call gs as `gs -I$DST'
        or `env GS_LIB=$DST gs'
";
print STDERR "Done.\n";
