#!/bin/sh --
eval '(exit $?0)' && eval 'exec perl -w -x -S $0 ${1+"$@"}' && eval 'exec perl 
if 0; # the 1st 4 lines make compatible with kernel/perl/bash/ash/sh/csh
#!perl -w

# reps.pl
# by pts@fazekas.hu at Thu Oct 26 08:05:21 CEST 2000
# 0.0 original
# 0.1 minor update
# 0.2 major update (subst.dat) at Sat Oct 28 09:46:59 CEST 2000
# 0.3 all *show operators at Sun Oct 29 02:11:08 CEST 2000
# 0.31 bugfixes, now finds .dat on the $PATH Tue Feb  5 11:50:11 CET 2002
#
# OK : no need to count in metrics.dat
# Imp: warn for unsupported accents in Perl
# Imp: /ae
# OK : run faster when metrics.dat is not needed
# OK : TR s ISO-8859-2Encoding ne legyen hardcode-olva procset.dat-ba
use integer;
use strict;

sub ONE(){1}

my $VERSION="0.31";
my $LICENSE="Released under the GNU GPL, version >=2.0";
my $COPYRIGHT="Copyright (C) Early February 2002 by <pts\@fazekas.hu>";
my $PRODUCT="rePS $VERSION";

# --- by pts@fazekas.hu at Tue Feb  5 11:51:32 CET 2002
my $MY_DIR;
if ($0=~m@\A(.*)/[^/]+@ms) {
  $MY_DIR=$1
} else {
  for ('.', split ':', $ENV{PATH}) {
    if (-f "$_/subst.dat") { $MY_DIR=$_; last }
  }
  die "$0: cannot find subst.dat on \$PATH\n" if! defined $MY_DIR;
}


# ---


my %T;
sub ps_toks($) {
  # ps_toks tokenizes the input strings according to PostScript-like rules
  # returns a listref
  my $S=$_[0];
  
  # vvv not advanced enough: lists are not taken as lists
  $S=~s/%.*//g; # remove comments
  $S=~s/([\[\]])/ $1 /g;
  my $L=[split" ",$S]; # <-- " " is magical: starting and trailing \s removed
  for (@$L) { die "token syntax error: $_\n" unless exists $T{$_} or /\A([+-]?\d+|\[|\])\Z(?!\n)/ or m@\A/[\-_\.a-zA-Z0-9]+\Z(?!\n)@ }
  return $L;

  # vvv _very_ slow, but handles [] as listrefs (turned off)
  #$S=~s/%.*//g;				# remove comments
  #$S=~y/ \t\r\n\x00-\x1F'\\/    /d;	# remove quoting
  #$S=~s/\A\s*/[/; $S=~s/\s*\Z/]/;	# trim
  #$S=~s/\s*([^\[\]\s]+)\s*/'$1',/g;	# quote
  #$S=eval $S; # dangerous?! -- maybe not, see the `quote' s///
  #die "token parse error: $_\n" if$@;
  #$S;
}

my $FORFN; # Imp: recursive
sub for_file($&;$) {
  # for_file calls the sub for each line of file
  my($FN,$SUB,$L)=@_;
  %T=defined($L)?(map{$_=>1}@$L):();
  $FORFN=$FN;
  die "$0: open $FN: $!\n" unless open F,"< $FN";
  while (<F>) { $SUB->(ps_toks $_) }
  die unless close F;
}

# --- main

die "Usage: $0 FILENAME.eps [/Fontname...]\n" if !@ARGV;
my $EPSFN=shift@ARGV;
my @FS=@ARGV;

my @LA=qw{/cedilla /ogonek}; # Low Accents (accents to put _below_ the letter)
my @HA=qw{/grave /ring /tilde /circumflex /dieresis /hungarumlaut
          /acute /breve /caron /dotaccent};
my %A=map{$_=>1}@LA,@HA;


# vvv OgonkiEncoding
my $OE=ps_toks q{
/.notdef /exclamdown /cent /sterling /fraction /yen /florin /quotesingle
/quotedblleft /guillemotleft /guilsinglleft /guilsinglright /fi /fl /endash /dagger
/daggerdbl /periodcentered /paragraph /bullet /quotesinglbase /quotedblbase /quotedblright /guillemotright
/ellipsis /perthousand /questiondown /grave /circumflex /tilde /macron /ring
/space /exclam /quotedbl /numbersign /dollar /percent /ampersand /quoteright
/parenleft /parenright /asterisk /plus /comma /minus /period /slash
/zero /one /two /three /four /five /six /seven
/eight /nine /colon /semicolon /less /equal /greater /question
% 100
/at /A /B /C /D /E /F /G
/H /I /J /K /L /M /N /O
/P /Q /R /S /T /U /V /W
/X /Y /Z /bracketleft /backslash /bracketright /asciicircum /underscore
/quoteleft /a /b /c /d /e /f /g
/h /i /j /k /l /m /n /o
/p /q /r /s /t /u /v /w
/x /y /z /braceleft /bar /braceright /asciitilde /.notdef
% 200
/.notdef /emdash /AE /ordfeminine /Oslash /OE /ordmasculine /ae
/dotlessi /oslash /oe /threesuperior /thorn /twosuperior /threequarters /Eth
/trademark /registered /onequarter /Thorn /logicalnot /plusminus /minus /onesuperior
/copyright /mu /eth /brokenbar /onehalf /dotlessj /.notdef /.notdef
/space /Aogonek /breve /Lslash /currency /Lcaron /Sacute /section
/dieresis /Scaron /Scedilla /Tcaron /Zacute /hyphen /Zcaron /Zdotaccent
/degree /aogonek /ogonek /lslash /acute /lcaron /sacute /caron
/cedilla /scaron /scedilla /tcaron /zacute /hungarumlaut /zcaron /zdotaccent
% 300
/Racute /Aacute /Acircumflex /Abreve /Adieresis /Lacute /Cacute /Ccedilla
/Ccaron /Eacute /Eogonek /Edieresis /Ecaron /Iacute /Icircumflex /Dcaron
/Eth /Nacute /Ncaron /Oacute /Ocircumflex /Ohungarumlaut /Odieresis /multiply
/Rcaron /Uring /Uacute /Uhungarumlaut /Udieresis /Yacute /Tcedilla /germandbls
/racute /aacute /acircumflex /abreve /adieresis /lacute /cacute /ccedilla
/ccaron /eacute /eogonek /edieresis /ecaron /iacute /icircumflex /dcaron
/dbar /nacute /ncaron /oacute /ocircumflex /ohungarumlaut /odieresis /divide
/rcaron /uring /uacute /uhungarumlaut /udieresis /yacute /tcedilla /dotaccent
};
sub oe($) {
  my $S=shift;
  return $OE->[$S] if $S=~/\A(\d+)\Z(?!\n)/;
  $S;
}

# $OE=ps_toks '3 [/4 5]';
# print scalar @{$OE},"\n";

my %SETP; # active?
my %SETE; # set contents: setname:[fname...]
my %FU; # fname:uniqueid
my %FA; # fany:fname
my %FN; # fname:[alias...]

for_file "$MY_DIR/fontname.dat", sub {
  my $L=$_[0];
  return if !@$L;
  if (@$L==1) { # sets
    if (not exists $SETE{$L->[0]}) {
      $SETE{$L->[0]}=[];
      $SETP{$L->[0]}=1;
    } elsif ($SETP{$L->[0]}) { $SETP{$L->[0]}=0 }
    else { $SETP{$L->[0]}=1 }
  } else { # font description
    my(%A,$N,$U); # aliases, fname, uniqueid
    for (@$L) {
      if (!/\D/) { $U=$_ }
      elsif (/\A\/\./) { $N=$_ }
      else { $A{$_}=1 }
    }
    die "missing /.fname ($FORFN:$.)\n" if !defined $N;
    die "/.fname $N multiply defined ($FORFN:$.)\n" if exists $FN{$N};
    $FN{$N}=[];
    $FU{$N}=defined($U)?$U:0;
    for (keys%A) {
      push @{$FN{$N}}, $_;
      if (exists$FA{$_}) {
        print STDERR "skipping redef of $_ ($FORFN:$.)\n";
      } else {
        $FA{$_}=$N;
      }
    }
    for (keys%SETP) { push @{$SETE{$_}},$N if $SETP{$_} }
  }
  # print @{$_[0]},"\n";
};
print STDERR scalar(keys%FN)," known fonts and ",scalar(keys%FA)," aliases.\n";
print STDERR scalar(keys%SETE), " known font sets.\n";

my %SI; # sid:[included_sids]
my %SC; # sid:{oldglyph:newglyph}
my %SM; # sid:{missingglyph:[2glyphs]}
{ my $G='/.misc';
  for_file "$MY_DIR/subst.dat", sub {
    my $L=$_[0];
    return if!@$L;
    if (@$L==1) { $G=$L->[0]; $SI{$G}=[]; $SC{$G}={}; $SM{$G}={}; return }
    # if ($L->[-1]=~/\A\d+\Z(?!\n)/) { push @$L, $L->[-2] }
    if ($L->[0]eq'include') {
      shift @$L;
      for (@$L) {
        die "unknown include @$L ($FORFN:$.)\n" if! exists $SI{$_};
        push @{$SI{$G}}, @{$SI{$_}}, $_;
        # ^^^ the include tree is built up just in the good order
      }
      # push @{$SI{$G}}, @$L;
      return
    }
    if ($L->[0]eq'change') {
      die "change OLD NEW expected ($FORFN: $.)\n" if @$L!=3;
      $SC{$G}{$L->[1]}=$L->[2];
      return;
    }
    my($A,$B);
    # my $D=shift@$L;
    for (my $I=1;$I<@$L;$I+=2) {
      if ($L->[$I]=~/\A(\d+)\Z(?!\n)/) {
        # die "@$L\n";
        $B=$L->[$I+1];  $B=$L->[$I-1] if! defined $B;
        $A=$L->[$I]+1;  $A=length($B)+1 if $A<2 or $A>length($B)+1;
        ($A,$B)=(substr($B,0,$A),"/".substr($B,$A));
      } else {
        # die "@$L\n";
        $B=$L->[$I+1]; $B=0 if! defined $B;
        $A=$L->[$I];
      }
      # print STDERR "$A,$B,\n";
      push @{$SM{$G}{$L->[0]}}, $B, $A;
    }
    # print STDERR "@$L\n"; 
  }, [qw{include change}];
}
print STDERR scalar(keys %SI), " glyph substitution rulesets.\n";
# print STDERR keys %SI;

my %FT;
my %TC; # oldglyph:newglyph
my %TM; # missingglyph:[2glyphs]
for (@FS) {
  # print ".$_\n";
  if (exists $SI{$_}) { # a substitution ruleset
    my($K,$V);
    for my $I (@{$SI{$_}},$_) {
      $TC{$K}=$V while ($K,$V)=each%{$SC{$I}};
      push @{$TM{$K}},@$V while ($K,$V)=each%{$SM{$I}};
    }
  }elsif (exists $SETE{$_}) {
    for my $K (@{$SETE{$_}}) { $FT{$K}=1 }
  } elsif (exists $FA{$_}) { $FT{$FA{$_}}=1 }
  elsif (exists $FN{$_}) { $FT{$_}=1 }
  else { die "unknown font/substitution in command line: $_\n" }
}
# print STDERR %TM,"\n";
# print STDERR @{$TM{"/Lslash"}},"\n";
# exit;
print STDERR scalar(keys%TM), " glyphs may be composed.\n";
print STDERR scalar(keys%TC), " glyphs will be changed.\n";
print STDERR scalar(keys%FT), " fonts will be assisted.\n";
my $REENCP=%FT;
# print "@FT\n";

# die "cshow.ps: $!\n" unless open CSPS, "< cshow.ps"; # not needed!
die "$EPSFN: $!\n" unless open IN, "< $EPSFN";
die unless open OUT, ">& STDOUT";
sub IN_line() {
  my $S=<IN>;
  die "unexpected eof ($.)\n" if !defined$S;
  $S;
}

sub real_work() {
  # real_work does the real work: puts encoding tables etc
  print OUT "%%BeginProcSet: rePS_rePSDict_$VERSION
% vvv This part was inserted by $0 $VERSION at ",scalar localtime,".
%     $PRODUCT
%     $COPYRIGHT
%     $LICENSE
%     (insertion lasts till EndProcSet)
";
  print OUT"[ @LA\n  @HA\n]",scalar(@LA),"\n";
  die "$MY_DIR/procset.dat: $!\n" unless open F, "< $MY_DIR/procset.dat";
  my $L="";
  while (<F>) {
    # We compact the PostScript program a little bit.
    # Luckily there are no spaces inside strings... (If there were, this
    # simple regexp substitution wouldn't work.

    # vvv Basic compacting: lines are not joined    
    # s/\s*%.*//m;s/\s*\Z//;s/\A\s*//;s/\s*([\/\(\)\{\}\[\]])\s*/$1/g;
    # print OUT "$_\n" if length

    s/\s*%.*//m;s/\s*\Z//;s/\A\s*//;s/\s+/ /g;s/\s*([\/\(\)\{\}\[\]])\s*/$1/g;
    next unless length;
    if (length$L) {$L.=" $_"} else {$L=$_}
    $L=~s/\s*([\/\(\)\{\}\[\]])\s*/$1/g;
    if (72<length$L) {
      my $M=$L; $M=~y/\/\(\)\{\}\[\]/ /;
      # print STDERR "$M.\n";
      my $I=rindex $M, " ", 72;
      $I=index($M," ",72) if $I==-1;
      if ($I==-1) {$I=length$L;$L.=" "}
      print OUT substr($L,0,$I),"\n";
      $L=substr($L,$I);
      $L=~s/\A\s+//;
    }
  }
  print OUT "$L\n";
  close F;
  
  print OUT"\nrePSDict begin\n";
  print OUT scalar(keys %TC)," dict dup /CH exch def\n";
  while (my($K,$V)=each%TC) { print OUT "\tdup $K $V put\n" }
  print OUT "readonly pop\n\n";
  print OUT scalar(keys %TM)," dict dup /CO exch def\n";
  while (my($K,$V)=each%TM) { print OUT "\tdup $K [", join(' ',reverse@$V), "] put\n" }
  print OUT "readonly pop\n\n";
  
  if ($REENCP) {
    my $C=0;
    my $P=0; # dump current font?
    my $OV='';
    my $POP="";
    my $OUT="";
    for_file "$MY_DIR/metrics.dat", sub {
      $C++;
      my $L=$_[0];
      return if!@$L;
      if ($L->[0]=~/\A\/\./) {
        $P=0;
        if (not exists $FN{$L->[0]}) {
          print STDERR "skipping unknown font $L->[0] ($FORFN:$.)\n";
        } elsif (exists $FT{$L->[0]}) {
          print STDERR "assisting $L->[0]\n";
          $P=1;
          $OV.="dup $FU{$L->[0]} $L->[0] put\n" if $FU{$L->[0]};
          for my $A (@{$FN{$L->[0]}}) {
            $OV.="dup $A $L->[0] put\n" if $FU{$L->[0]};
            $OV.="dup (".substr($A,1)."--$FU{$L->[0]}) $L->[0] put\n" if $FU{$L->[0]};
          }
          # print OUT "ZZZ.\n";
          print OUT +($OUT=~y/\n/\n/)-1,$OUT if length $OUT;
          print OUT $POP; $POP="readonly pop\n\n";
          # print OUT $L->[1],
          $OUT=
          " dict dup /OG exch $L->[0] exch xput\n";
          # <STDIN>;
        }
        # print STDERR "$L->[0]\n";
      } else { # normal, data line
        #print OUT
        $OUT.=
        "\tdup $L->[0]\[".oe($L->[2])." $L->[3] $L->[4]".oe($L->[5])."\] put\n" if $P;
        # ^^^ space bugfix by pts@fazekas.hu at Tue Feb  5 12:08:28 CET 2002
      }
    };
    # vvv $OUT is _not_ empty now
    print OUT +($OUT=~y/\n/\n/)-1,$OUT,$POP,ONE()*($OV=~y/\n/\n/)," dict dup /OV exch def\n${OV}readonly pop end\n";
    # ^^^ Imp: `2*' gs 5.50-ben segfault-ol, ha kicsi a dict. Mirt??
    #     (j verzi 2000.10.28 mr nem segfaultol...)
    print STDERR "$C lines of font metrics assistance.\n";
  } else {print OUT"end\n\n"}
  print OUT "%%EndProcSet\n\n";
}

die "not a PostScript file\n" if ($_=IN_line)!~/^%!PS-Adobe-/;
print OUT $_;
while (($_=IN_line)!~/^%%EndComments/) { print OUT }
print OUT $_;
# if (($_=IN_line)=~/^%%Begin/) { print OUT; real_work() }
# else { my $S=$_; real_work(); print OUT $S; }
real_work();
while (read IN, $_, 4096) { print OUT $_ }
close OUT;
close IN;
print STDERR "Done.\n";
